% This is to plot both model and measured time series
% data.  Model data is from wissw1.for reading in WIS
% data downloaded from CERC home page.
% Measured data can be from: (1) wissw1.for reading
% in NDBC data downloaded from NDBC home page, or
% (2) nbuoy1.for reading in NDBC or NEMO data from
% CERC home page.
%function fig2sets
clear all

%disp(         'Type in Matlab Version Number (4 for 1984-93)');
%version=input('                              (5 for 1994-  ) ');
version=5;
disp(' ');
disp('Get a buoy data file (e.g., 51001980.dat)');
disp(' ');
[fn1,path1]=uigetfile('*.*','Get a NDBC Buoy File');
disp(fn1);
disp(' ');
%
p1=load([path1,fn1]);
%
disp('type in 1 for Metric system (m, m/sec)');
unit=input('     or 2 for English system (ft, knot): ');
disp(' ');
if unit<=1
unit=1;
else
unit=3.3025;
end

iyear=input('type in a single year (e.g., 94): ');
disp(' ');
imon1=input('type in starting month id (e.g., 1 for jan): ');
fprintf('type in  ending  month id (e.g., 3 for mar) \n');
disp       ('     (13 for Jan of the following year)');
imon2=input('     (0 for selected days in the same month): ');
%
samemon=1;
if imon2==0
imon2=imon1;
samemon=0;
disp(' ');
iday1=input('type in starting day (e.g., 2 to start Day 2): ');
idayn=input('type in ending   day (e.g., 5 to end   Day 5): ');
iday1=iday1-1;
disp(' ');
end
%
imon3=imon2+1;
fyear=iyear;
fmon2=imon2;
if imon3>13
fmon2=fmon2-12;
fyear=iyear+1;
%

disp('type in 1 to get following year buoy data');
igetfile=input('     or 0 to skip: ');
if igetfile==1
disp(' ');
disp('Get following year buoy data file (e.g., 51001990.dat)');
disp(' ');
[fn11,path11]=uigetfile('*.*','Get following year Buoy File');
disp(fn11);
disp(' ');
p11=load([path11,fn11]);
p1=[p1;p11];
end
end
[ppp,nc1]=size(p1);
%
nc0=length(fn1);
nc=1;
for i=1:nc0
if fn1(i)=='.'
nc=i;
end;
end;
mode=fn1(nc+1);
if mode=='d'
for i=1:5
fn9(i)=fn1(i);
end
else
fn9=input('type in a legend for this file (e.g., wis/1/ow): ','s');
end
%
disp(' ');
[fn2,path2]=uigetfile('*.*','Get a Buoy or model output file (e.g., 51001980.a2)');
disp(fn2);
nc0=length(fn2);
nc=1;
for i=1:nc0
if fn2(i)=='.'
nc=i;
end;
end;
mode=fn2(nc+1);
lvl=fn2(nc+2);
model='000';
if mode=='a'
model='wam';
elseif mode=='i'
model='wis';
elseif mode=='w'
model='ww3';
end;
if model=='000'
string1=input('type in a legend for this file (e.g., wis/1/ow): ','s');
else
%
disp(' ');
disp('type in wind source label (e.g, ow or ncep)');
disp(      '     or 1 to give a new legend');
winp=input('     or 0 to use default (ow): ','s');
disp(' ');
%
if winp(1)=='0'   
string1=[model,'/',lvl,'/ow'];
elseif winp(1)=='1'
string1=input('type in a new legend: ','s');
else
string1=[model,'/',lvl,'/',winp];
end
end
%
p2=load([path2,fn2]);
[ppp,nc2]=size(p2);
%
disp(' ');
disp('type in a Buoy or model output filename (e.g., 51001980.i2)');
fn3=input('     or 0 to skip: ','s');
if fn3(1)~='0'
%
nc0=length(fn3);
nc=1;
for i=1:nc0
if fn3(i)=='.'
nc=i;
end;
end;
mode=fn3(nc+1);
lvl=fn3(nc+2);
model='000';
if mode=='a'
model='wam';
elseif mode=='i'
model='wis';
elseif mode=='w'
model='ww3';
end;
if model=='000'
string2=input('type in a legend for this file (e.g., wis/3/ow): ','s');
else
%
disp(' ');
disp('type in wind source label (e.g, ow or ncep)');
disp(      '     or 1 to give a new legend');
winp=input('     or 0 to use default (ow): ','s');
disp(' ');
%
if winp(1)=='0'   
string2=[model,'/',lvl,'/ow'];
elseif winp(1)=='1'
string2=input('type in a new legend: ','s');
else
string2=[model,'/',lvl,'/',winp];
end
end
%
p3=load(fn3);
[ppp,nc3]=size(p3);
end
%
mstr='JanFebMarAprMayJunJulAugSepOctNovDec';
mstr=[mstr,mstr];
imon=[0 31 28 31 30 31 30 31 31 30 31 30 31 ...
        31 28 31 30 31 30 31 31 30 31 30 31];
if rem(iyear,4)==0
imon(3)=29;
end

imnn(1)=imon(1);
for i=2:25
imnn(i)=imnn(i-1)+imon(i);
end

mm9=imnn(imon3)-imnn(imon1);
xlower=0;
xupper=mm9;

dwav=1;
if nc1>=12 & nc2>=12
if fn3(1)=='0' | nc3>=12
disp(' ');
disp('type in 1 for spectral peak mean wave dir,');
dwav=input('     or 2 for 2-D spectral  mean wave dir: ');
end
end
disp(' ');

if nc1>=11
iy=p1(:,2);
mm=p1(:,3);
id=p1(:,4);
ih=p1(:,5);
ht=p1(:,6);
if unit>2
ht=ht*unit;
end
td=p1(:,7);
%ta=p1(:,8);
hd=p1(:,9);
if nc1>=12 & dwav==2
hd=p1(:,12);
end
wd=p1(:,11);
ws=p1(:,10);
if unit>2
ws=ws/.5144;
end
else
disp('ok1');
ymdh=p1(:,2);
yy=fix(ymdh/1000000);
iy=yy-fix(yy/100)*100;
mm=fix((ymdh-yy*1000000)/10000);
id=fix((ymdh-yy*1000000-mm*10000)/100);
ih=ymdh-yy*1000000-mm*10000-id*100;
ht=p1(:,3);
if unit>2
ht=ht*unit;
end
td=p1(:,4);
hd=p1(:,5);
wd=p1(:,7);
ws=p1(:,6);
if unit>2
ws=ws/.5144;
end
end

if nc2>=11
iy2=p2(:,2);
mm2=p2(:,3);
id2=p2(:,4);
ih2=p2(:,5);
ht2=p2(:,6);
if unit>2
ht2=ht2*unit;
end
td2=p2(:,7);
hd2=p2(:,9);
if nc2>=12 & dwav==2
hd2=p2(:,12);
end
wd2=p2(:,11);
ws2=p2(:,10);
if unit>2
ws2=ws2/.5144;
end
else
ymdh2=p2(:,2);
yy2=fix(ymdh2/1000000);
iy2=yy2-fix(yy2/100)*100;
mm2=fix((ymdh2-yy2*1000000)/10000);
id2=fix((ymdh2-yy2*1000000-mm2*10000)/100);
ih2=ymdh2-yy2*1000000-mm2*10000-id2*100;
ht2=p2(:,3);
if unit>2
ht2=ht2*unit;
end
td2=p2(:,4);
hd2=p2(:,5);
wd2=p2(:,7);
ws2=p2(:,6);
if unit>2
ws2=ws2/.5144;
end
end

if fn3(1)~='0'
if nc3>=11
iy3=p3(:,2);
mm3=p3(:,3);
id3=p3(:,4);
ih3=p3(:,5);
ht3=p3(:,6);
if unit>2
ht3=ht3*unit;
end
td3=p3(:,7);
hd3=p3(:,9);
if nc3>=12 & dwav==2
hd3=p3(:,12);
end
wd3=p3(:,11);
ws3=p3(:,10);
if unit>2
ws3=ws3/.5144;
end
else
ymdh3=p3(:,2);
yy3=fix(ymdh3/1000000);
iy3=yy3-fix(yy3/100)*100;
mm3=fix((ymdh3-yy3*1000000)/10000);
id3=fix((ymdh3-yy3*1000000-mm3*10000)/100);
ih3=ymdh3-yy3*1000000-mm3*10000-id3*100;
ht3=p3(:,3);
if unit>2
ht3=ht3*unit;
end
td3=p3(:,4);
hd3=p3(:,5);
wd3=p3(:,7);
ws3=p3(:,6);
if unit>2
ws3=ws3/.5144;
end
end
end

clf
set(gcf,'paperposition',[1.1,.2,7,9.8])
set(gcf,'paperorientation','portrait')

ylevel=[90 90 900 900 90];
ylab(1,1:3)=[4 8 12];
ycap(1,1:3)=[5 10 15];
ylab(2,1:3)=[8 16 24];
ycap(2,1:3)=[10 20 30];
ylab(3,1:3)=[360 360 360];
ycap(3,1:3)=[361 361 361];
ylab(4,1:3)=[360 360 360];
ycap(4,1:3)=[361 361 361];
ylab(5,1:3)=[16 24 40];
ycap(5,1:3)=[20 30 50];

ifig=0;
for k=1:5
if k==1
hs=ht;
hs2=ht2;
if fn3(1)~='0'
hs3=ht3;
end
ycapt='Wave Height Hs, m ';
if unit>2
ycapt='Wave Height Hs, ft';
end
end
if k==2
hs=td;
hs2=td2;
if fn3(1)~='0'
hs3=td3;
end
ycapt='Wave Period, sec ';
end
if k==3
hs=hd;
hs2=hd2;
if fn3(1)~='0'
hs3=hd3;
end
ycapt='Wave Direction  ';
end
if k==4
hs=wd;
hs2=wd2;
if fn3(1)~='0'
hs3=wd3;
end
ycapt='Wind Direction  ';
end
if k==5
hs=ws;
hs2=ws2;
if fn3(1)~='0'
hs3=ws3;
end
ycapt='Wind Speed, m/sec ';
if unit>2
ycapt='  Wind Speed, kt  ';
end
end

n=length(hs);
xx=nan;
yy=nan;
jj1=0;
mm0=mm;
for i=1:n
   if fyear==100 & iyear==99
      if iy(i)==0
      iy(i)=100;
      end
   end
   if imon3>13 & iy(i)==fyear
   mm0(i)=mm0(i)+12;
   end
icc=iy(i)*100+mm(i);
if icc>=iyear*100+imon1 & icc<=fyear*100+fmon2
if hs(i) < ylevel(k) & hs(i) >0
jj1=jj1+1;
yy(jj1)=hs(i);
xx(jj1)=imnn(mm0(i))+id(i)-1+ih(i)/24;
end
end
end
ymax=0;
if jj1~=0
xx=xx-imnn(imon1);
ymax=ylab(k,1);
for j=2:jj1
if abs(yy(j)-yy(j-1)) > 400 | abs(xx(j)-xx(j-1)) > 2
yy(j)=nan;
xx(j)=nan;
else
if yy(j) > ymax
ymax=yy(j);
end
end
end
end

n=length(hs2);
xx2=nan;
yy2=nan;
jj2=0;
mm0=mm2;
for i=1:n
   if fyear==100 & iyear==99
      if iy2(i)==0
      iy2(i)=100;
      end
   end
   if imon3>13 & iy2(i)==fyear
   mm0(i)=mm0(i)+12;
   end
icc=iy2(i)*100+mm2(i);
if icc>=iyear*100+imon1 & icc<=fyear*100+fmon2
if hs2(i) < ylevel(k) & hs2(i) >0
jj2=jj2+1;
yy2(jj2)=hs2(i);
xx2(jj2)=imnn(mm0(i))+id2(i)-1+ih2(i)/24;
end
end
end
if jj2~=0
xx2=xx2-imnn(imon1);
for j=2:jj2
if abs(yy2(j)-yy2(j-1)) > 400 | abs(xx2(j)-xx2(j-1)) > 2
yy2(j)=nan;
xx2(j)=nan;
else
if yy2(j) > ymax
ymax=yy2(j);
end
end
end
end

jj3=0;
if fn3(1)~='0'
n=length(ht3);
xx3=nan;
yy3=nan;
mm0=mm3;
for i=1:n
   if fyear==100 & iyear==99
      if iy3(i)==0
      iy3(i)=100;
      end
   end
   if imon3>13 & iy3(i)==fyear
   mm0(i)=mm0(i)+12;
   end
icc=iy3(i)*100+mm3(i);
if icc>=iyear*100+imon1 & icc<=fyear*100+fmon2
if hs3(i) < ylevel(k) & hs3(i) >0
jj3=jj3+1;
yy3(jj3)=hs3(i);
xx3(jj3)=imnn(mm0(i))+id3(i)-1+ih3(i)/24;
end
end
end
if jj3~=0
xx3=xx3-imnn(imon1);
for j=2:jj3
if abs(yy3(j)-yy3(j-1)) > 400 | abs(xx3(j)-xx3(j-1)) > 2
yy3(j)=nan;
xx3(j)=nan;
else
if yy3(j) > ymax
ymax=yy3(j);
end
end
end
end
end

yylab=ylab(k,:);
yycap=ycap(k,:);

yupper=yycap(3);
ymark3=yylab(3);
if ymax < yycap(1)
yupper=yycap(1);
ymark3=yylab(1);
end
if ymax >= yycap(1) & ymax < yycap(2)
yupper=yycap(2);
ymark3=yylab(2);
end
ymark=[0:ymark3/4:ymark3];

xa1(1)=xx(1);
ya1(1)=yy(1);
xa1(2)=xx(1);
ya1(2)=yy(1);
igo=0;
if length(xx)>1
igo=1;
end
if length(xx2)>1
igo=1;
end
if fn3(1)~='0'
if length(xx3)>1
igo=1;
end
end
if igo==1
ifig=ifig+1;
subplot(5,1,ifig);
if k==1
if jj3~=0
plot(xa1,ya1,'+r',xa1,ya1,'b',xa1,ya1,'g','markersize',2)
else
plot(xa1,ya1,'+r',xa1,ya1,'b','markersize',2)
end
hold on
end

if k==2
plot(xa1,ya1,'+r','markersize',2)
legend('peak period')
hold on
end
if k==3 & dwav==2
plot(xa1,ya1,'+r','markersize',2)
legend('2-D spectral mean')
hold on
end
if k==3 & dwav==1
plot(xa1,ya1,'+r','markersize',2)
legend('spectral peak mean')
hold on
end

if jj1~=0
plot(xx,yy,'+r','markersize',2)
hold on
  if k<=3
    if k==1
    file11=fopen('ht11.txt','wt+');
    elseif k==2
    file11=fopen('pd11.txt','wt+');
    else
    file11=fopen('md11.txt','wt+');
    end
    for i2=1:length(xx)
    fprintf(file11,'%9.5f %7.3f\n',xx(i2),yy(i2));
    end
  fclose(file11);
  end
end
if jj2~=0
plot(xx2,yy2,'-b')
hold on
  if k<=3
    if k==1
    file22=fopen('ht22.txt','wt+');
    elseif k==2
    file22=fopen('pd22.txt','wt+');
    else
    file22=fopen('md22.txt','wt+');
    end
    for i2=1:length(xx2)
    fprintf(file22,'%9.5f %7.3f\n',xx2(i2),yy2(i2));
    end
  fclose(file22);
  end
end
if jj3~=0
plot(xx3,yy3,'-g')
hold on
  if k<=3
    if k==1
    file33=fopen('ht33.txt','wt+');
    elseif k==2
    file33=fopen('pd33.txt','wt+');
    else
    file33=fopen('md33.txt','wt+');
    end
    for i2=1:length(xx3)
    fprintf(file33,'%9.5f %7.3f\n',xx3(i2),yy3(i2));
    end
  fclose(file33);
  end
end

if samemon==1
set(gca,'XLim',[0,mm9],'YLim',[0,yupper]);
else
set(gca,'XLim',[iday1,idayn],'YLim',[0,yupper]);
end
%
if imon2-imon1 ==11
set(gca,'XTick',imnn,'YTick',[0:ymark(2):ymark(5)]);
else
if samemon==1
iok=0;
if mm9>62
iok=ceil(mm9/10)+1;
if imon1>2
set(gca,'XTick',[0:10.3:mm9],'YTick',[0:ymark(2):ymark(5)]);
else
set(gca,'XTick',[0:10.1:mm9],'YTick',[0:ymark(2):ymark(5)]);
end
else
set(gca,'XTick',[0:1:mm9],'YTick',[0:ymark(2):ymark(5)]);
end
else
set(gca,'XTick',[iday1:1:idayn],'YTick',[0:ymark(2):ymark(5)]);
end
jmon=imon1+1;
j1=0;
if samemon==1
for j=0:mm9
if j1 >imon(jmon)
j1=j1-imon(jmon);
jmon=jmon+1;
end

if j > 0
lablx(j,1:2)=['  '];
end
if j1==1
lablx(j,2)=int2str(j1);
end
if j1==5 & j<5
lablx(j,2)=int2str(j1);
end
if j1==10
lablx(j,:)=int2str(j1);
end
if j1==15 & j<5
lablx(j,:)=int2str(j1);
end
if j1==20
lablx(j,:)=int2str(j1);
end
if j1==25 & j<5
lablx(j,:)=int2str(j1);
end
j1=j1+1;
end
lablx(mm9,:)=int2str(j1-1);
lablx(mm9+1,:)=['  '];
for iokk=1:iok
lablx(iokk,:)=[' 1'];
if mod(iokk,3)==2
lablx(iokk,:)=['10'];
end
if mod(iokk,3)==0
lablx(iokk,:)=['20'];
end
end
end
if samemon==0
for j=iday1:idayn
   j1=j1+1;
   lablx(j1,1:2)=['  '];
   if j+1<10
   lablx(j1,2)=int2str(j+1);
   else
   lablx(j1,1:2)=int2str(j+1);
   end
end
end
if version==4
set(gca,'xticklabels',lablx)
else
set(gca,'xticklabel',lablx)
end

end

if k==3 | k==4
lably(1,1:2)=' N';
lably(2,1:2)=' E';
lably(3,1:2)=' S';
lably(4,1:2)=' W';
lably(5,1:2)='  ';
else
for j=1:5
lably(j,1:2)=['  '];
if ymark(j) <10
lably(j,2)=int2str(ymark(j));
else
lably(j,:)=int2str(ymark(j));
end
end
end

if ifig==1
if jj3~=0
legend(fn9,string1,string2)
else
legend(fn9,string1)
end
end

if version==4
set(gca,'yticklabels',lably)
else
set(gca,'yticklabel',lably)
end
ylabel(ycapt,'fontsize',12)
set(gca,'FontSize',10)
if samemon==0
axis([iday1 idayn 0 yupper])
else
axis([xlower xupper 0 yupper])
if k==1
fprintf('x-axis range (days) is [0,%3.0f]\n',mm9);
disp('type in new x-axis range (days)');
cpair=input('     (0 0 to skip): ','s');
dpair=sscanf(cpair,'%f');
if length(dpair)==1 & dpair(1)==0
dpair=[0 0];
end
xlow=dpair(1);
xhgh=dpair(2);
if xhgh~=0 | xlow~=0
xupper=xhgh;
xlower=xlow;
axis([xlower xupper 0 yupper]);
end
end
end
end
end

for i=imon1:imon2
st=(3*(i-1)+1);
if imon2-imon1 ==11
month=mstr(st);
else
month=mstr(st:st+2);
end
xpo1=mm9/(imon3-imon1)*(i-imon1+1)-20;
ypo1=-1.5*ymark(2);
if i==imon2
ystr=int2str(fyear);
if length(ystr)==1
ystr(2)=ystr(1);
ystr(1)='0';
end
%if imon2-imon1 ==11
%if fyear<10
%month=[month,'(0',ystr,')'];
%else
%month=[month,'(',ystr,')'];
%end
%else
%if fyear>50
%month=[month,' (19',ystr,')'];
%elseif fyear<10
%month=[month,' (200',ystr,')'];
%else
%month=[month,' (20',ystr,')'];
%end
%end
month=[month,'  ',ystr];
end

if iyear~=fyear
ystr=int2str(iyear);
if length(ystr)==1
ystr(2)=ystr(1);
ystr(1)='0';
end
%if i==12 & imon2-imon1<7
%if fyear>50
%month=[month,' (19',ystr,')'];
%elseif fyear<10
%month=[month,' (200',ystr,')'];
%else
%month=[month,' (20',ystr,')'];
%end
%end
month=[month,'  ',ystr];
end
if samemon==0
xpo1=(iday1+idayn)/2-(idayn-iday1)/25;
end
text(xpo1,ypo1,month,'fontsize',12)
end
disp(' ');
subplot(5,1,1)
titlein=input('Type in title: ','s');
title(titlein);
